/**
 * Fonts related mixins.
 */

/**
 * Generates a complete font face declarations
 * where invoked
 *
 * @type mixin
 *
 * @param $font-family The with which the font family will be called
 * @param $font-path   The path to the fonts directory relative to the compiled stylesheet
 * @param $font-file   The name of the actual font file
 * @param $font-weight The font weight (normal, bold, lighter)
 * @param $font-weight The font style (normal, italic)
 *
 * Example Usage:
 * @include font-face('Open Sans', '../fonts/', 'OpenSans-regular-webfont', bold, italic)
 */
@mixin font-face($font-family, $font-path, $font-file, $font-weight: normal, $font-style: normal ) {
    @font-face {
        font-family: $font-family;
        src: url($font-path + $font-file + '.eot');
        src: url($font-path + $font-file + '.eot?#iefix') format('embedded-opentype'),
            url($font-path + $font-file + '.woff') format('woff'),
            url($font-path + $font-file + '.ttf') format('truetype'),
            url($font-path + $font-file + '.svg#{$font-family}') format('svg');
        font-weight: $font-weight;
        font-style: $font-style;
    }
}

/**
 * A loop to run through each font family
 * and print the font face declarations of each
 * variant
 *
 * Dependencies
 * variable - $font-path
 * mixin    - font-face
 */
@mixin loadFonts($fonts) {
    @each $font-family, $font-variants in $fonts {
        @each $variant in $font-variants {
            $font-path: $font-path !global;
            $font-file: nth($variant, 1);
            $font-weight: nth($variant, 2);
            $font-style: nth($variant, 3);

            @include font-face($font-family, $font-path, $font-file, $font-weight: normal, $font-style: normal);
        }
    }
}

$rem-baseline: 16px !default;
$rem-fallback: false !default;
$rem-px-only: false !default;

@function rem-separator($list, $separator: false) {
    @if $separator == "comma" or $separator == "space" {
        @return append($list, null, $separator);
    }

    @if function-exists("list-separator") == true {
        @return list-separator($list);
    }

    // list-separator polyfill by Hugo Giraudel (https://sass-compatibility.github.io/#list_separator_function)
    $test-list: ();
    @each $item in $list {
        $test-list: append($test-list, $item, space);
    }

    @return if($test-list == $list, space, comma);
}

@mixin rem-baseline($zoom: 100%) {
    font-size: $zoom / 16px * $rem-baseline;
}

@function rem-convert($to, $values...) {
    $result: ();
    $separator: rem-separator($values);

    @each $value in $values {
        @if type-of($value) == "number" and unit($value) == "rem" and $to == "px" {
            $result: append($result, $value / 1rem * $rem-baseline, $separator);
        } @else if type-of($value) == "number" and unit($value) == "px" and $to == "rem" {
            $result: append($result, $value / $rem-baseline * 1rem, $separator);
        } @else if type-of($value) == "list" {
            $value-separator: rem-separator($value);
            $value: rem-convert($to, $value...);
            $value: rem-separator($value, $value-separator);
            $result: append($result, $value, $separator);
        } @else {
            $result: append($result, $value, $separator);
        }
    }

    @return if(length($result) == 1, nth($result, 1), $result);
}

@function rem($values...) {
    @if $rem-px-only {
        @return rem-convert(px, $values...);
    } @else {
        @return rem-convert(rem, $values...);
    }
}

@mixin rem($properties, $values...) {
    @if type-of($properties) == "map" {
        @each $property in map-keys($properties) {
            @include rem($property, map-get($properties, $property));
        }
    } @else {
        @each $property in $properties {
            @if $rem-fallback or $rem-px-only {
                #{$property}: rem-convert(px, $values...);
            }
            @if not $rem-px-only {
                #{$property}: rem-convert(rem, $values...);
            }
        }
    }
}

/**
 * @example
 *     @include font-size(14px)
 * output:
 *     font-size: 14px;
 *     font-size: 0.8rem;
 */
@mixin font-size($size) {
    font-size: $size;
    font-size: rem($size);
}


@function decimal-round($number, $digits: 3) {
    $num: 1;

    @for $i from 1 through $digits {
        $num: $num * 10;
    }

    @return round($number * $num) / $num;
}

/**
 * Modular scale.
 * @param $lines - Number of steps to increment up or down the scale.
 * @param $base - The base value the scale starts at.
 * @param $ratio - The ratio the scale is built on.
 * @param $precision - Length of scale ms will be rounded to.
 */
@function modular-scale($lines, $base: 15px, $ratio: 1.25, $precision: 3) {
    @if $lines > 0 {
        @for $i from 1 through $lines {
            $base: $base * $ratio;
        }
    }

    @if $lines < 0 {
        @for $i from -1 through $lines {
            $base: $base / $ratio;
        }
    }

    @return decimal-round($base, $precision);
}
